<?php
/**
 * Модель модуля «Корзина товаров, оформление заказа»
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    6.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2018 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

class Cart_model extends Model
{

	/**
	 * Генерирует поля формы, созданные в конструкторе
	 *
	 * @param boolean $one_click сокращенная форма для быстрого заказа 
	 * @return void
	 */
	replace private function form_param($one_click = false)
	{
		$where = "show_in_form".($one_click ? "_one_click" : '')."='1'";
		$this->result["rows_param"] = $this->get_params(array("module" => "shop", "table" => "shop_order", "fields" => "info", "where" => $where));

		$multiple = array();
		$fields = array();
		foreach ($this->result["rows_param"] as $i => $row)
		{
			if(! empty($row["text"]))
			{
				$this->result["rows_param"][$i]["text"] = $this->diafan->_tpl->htmleditor($row["text"]);
			}
			$fields[] = 'p'.$row["id"];
			if ($row["type"] == "multiple" || $row["type"] == "color")
			{
				$multiple[] = $row["id"];
			}
			if(! $row["info"])
			{
					continue;
			}
			switch($row["info"])
			{
				case 'name':
					$this->result["user"]['p'.$row["id"]] = $this->diafan->_users->fio;
					break;

				case 'phone':
					$this->result["user"]['p'.$row["id"]] = $this->diafan->_users->phone;
					break;

				case 'email':
					$this->result["user"]['p'.$row["id"]] = $this->diafan->_users->mail;
					break;
			}
		}
		if($fields)
		{
			$this->form_errors($this->result, $this->result['form_tag'], $fields);
		}

		// данные о пользователе
		if ($this->diafan->_users->id)
		{
			$rows = DB::query_fetch_all("SELECT param_id, value FROM {shop_order_param_user} WHERE trash='0' AND user_id=%d", $this->diafan->_users->id);
			foreach ($rows as $row)
			{
				if(empty($row["value"]))
					continue;

				if (in_array($row["param_id"], $multiple))
				{
					$this->result["user"]['p'.$row["param_id"]][] = $row["value"];
				}
				else
				{
					$this->result["user"]['p'.$row["param_id"]] = $row["value"];
				}
			}
			$max_order_id = DB::query_result("SELECT MAX(id) FROM {shop_order} WHERE user_id=%d AND trash='0'", $this->diafan->_users->id);
			$rows = DB::query_fetch_all("SELECT value, param_id FROM {shop_order_param_element} WHERE trash='0' AND element_id=%d", $max_order_id);
			foreach ($rows as $row)
			{
				if(! empty($this->result["user"]['p'.$row["param_id"]]))
					continue;

				if (in_array($row["param_id"], $multiple))
				{
					$this->result["user"]['p'.$row["param_id"]][] = $row["value"];
				}
				else
				{
					$this->result["user"]['p'.$row["param_id"]] = $row["value"];
				}
			}
		}
		
		if($this->diafan->configmodules('subscribe_in_order', 'subscription'))
		{
			$this->result['subscribe_in_order'] = true;
		}
	}

}