<?php
/**
 * Редактирование товаров
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    6.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2018 OOO «Диафан» (http://www.diafan.ru/)
 */
if ( ! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Shop_admin
 */
class Shop_admin extends Frame_admin
{

	replace private function params()
	{
		// значения списков
		$options = DB::query_fetch_key_array("SELECT [name], id, param_id FROM {shop_param_select} ORDER BY sort ASC", "param_id");

		$cat_ids = array(0);
		if($this->diafan->values('cat_id'))
		{
			$cat_ids[] = $this->diafan->values('cat_id');
		}
		if($this->diafan->values('cat_ids'))
		{
			$cat_ids = array_merge($cat_ids, $this->diafan->values('cat_ids'));
		}
		else
		{
			$values = array();
			if (! $this->diafan->is_new)
			{
				$rows = DB::query_fetch_all("SELECT cat_id FROM {%s_category_rel} WHERE element_id=%d AND cat_id>0", $this->diafan->table, $this->diafan->id);
				foreach ($rows as $row)
				{
					if ($row["cat_id"] != $this->diafan->values("cat_id"))
					{
						$values[] = $row["cat_id"];
					}
				}
			}
			$this->diafan->values('cat_ids', $values, true);
			$cat_ids = array_merge($cat_ids, $values);
		}
		
		// выбирает все характеристики (при смене раздела/категории просто показываем или скрываем характеристики)
		$this->cache["params"] = DB::query_fetch_all("SELECT p.id, p.[name], p.type, p.required, p.[measure_unit], p.[text], p.config FROM {shop_param} AS p INNER JOIN {shop_param_category_rel} AS r ON r.element_id=p.id AND r.cat_id IN (%s) WHERE p.trash='0' GROUP BY p.id ORDER BY p.sort ASC", implode(',', $cat_ids));

		$this->cache["multiple_params"] = array();
		$this->cache["depend_price"] = array();
		foreach ($this->cache["params"] as &$row)
		{
			// значения списков
			if (in_array($row["type"], array('select', 'multiple', 'color')))
			{
				if($row["type"] == 'select')
				{
					$row["options"] = array(array('name' => $this->diafan->_('Нет'), 'id' => ''));
				}
				else
				{
					$row["options"] = array();
				}
				if(! empty($options[$row["id"]]))
				{
					$row["options"] = array_merge($row["options"], $options[$row["id"]]);
				}
			}
			if ($row["type"] == 'multiple' && $row["required"])
			{
				$this->cache["multiple_params"][] = $row;
				if($price_arr = $this->diafan->values("price_arr"))
				{
					foreach ($price_arr as $price)
					{
						if(! empty($price["param"][$row["id"]]))
						{
							$this->cache["depend_price"][$row["id"]] = true;
						}
					}
				}
			}
		}
	}

}
